<?php

namespace Ups_address\UPSaddressStruct;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Errors UPSaddressStruct
 * @package Ups_address
 * @subpackage Structs
 */
class Ups_addressErrors extends AbstractStructBase
{
    /**
     * The ErrorDetail
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * @var \Ups_address\UPSaddressStruct\Ups_addressErrorDetailType[]
     */
    public $ErrorDetail;
    /**
     * The TransactionReference
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \Ups_address\UPSaddressStruct\Ups_addressTransactionReferenceType
     */
    public $TransactionReference;
    /**
     * Constructor method for Errors
     * @uses Ups_addressErrors::setErrorDetail()
     * @uses Ups_addressErrors::setTransactionReference()
     * @param \Ups_address\UPSaddressStruct\Ups_addressErrorDetailType[] $errorDetail
     * @param \Ups_address\UPSaddressStruct\Ups_addressTransactionReferenceType $transactionReference
     */
    public function __construct(array $errorDetail = array(), \Ups_address\UPSaddressStruct\Ups_addressTransactionReferenceType $transactionReference = null)
    {
        $this
            ->setErrorDetail($errorDetail)
            ->setTransactionReference($transactionReference);
    }
    /**
     * Get ErrorDetail value
     * @return \Ups_address\UPSaddressStruct\Ups_addressErrorDetailType[]|null
     */
    public function getErrorDetail()
    {
        return $this->ErrorDetail;
    }
    /**
     * This method is responsible for validating the values passed to the setErrorDetail method
     * This method is willingly generated in order to preserve the one-line inline validation within the setErrorDetail method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateErrorDetailForArrayConstraintsFromSetErrorDetail(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $errorsErrorDetailItem) {
            // validation for constraint: itemType
            if (!$errorsErrorDetailItem instanceof \Ups_address\UPSaddressStruct\Ups_addressErrorDetailType) {
                $invalidValues[] = is_object($errorsErrorDetailItem) ? get_class($errorsErrorDetailItem) : sprintf('%s(%s)', gettype($errorsErrorDetailItem), var_export($errorsErrorDetailItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ErrorDetail property can only contain items of type \Ups_address\UPSaddressStruct\Ups_addressErrorDetailType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ErrorDetail value
     * @throws \InvalidArgumentException
     * @param \Ups_address\UPSaddressStruct\Ups_addressErrorDetailType[] $errorDetail
     * @return \Ups_address\UPSaddressStruct\Ups_addressErrors
     */
    public function setErrorDetail(array $errorDetail = array())
    {
        // validation for constraint: array
        if ('' !== ($errorDetailArrayErrorMessage = self::validateErrorDetailForArrayConstraintsFromSetErrorDetail($errorDetail))) {
            throw new \InvalidArgumentException($errorDetailArrayErrorMessage, __LINE__);
        }
        $this->ErrorDetail = $errorDetail;
        return $this;
    }
    /**
     * Add item to ErrorDetail value
     * @throws \InvalidArgumentException
     * @param \Ups_address\UPSaddressStruct\Ups_addressErrorDetailType $item
     * @return \Ups_address\UPSaddressStruct\Ups_addressErrors
     */
    public function addToErrorDetail(\Ups_address\UPSaddressStruct\Ups_addressErrorDetailType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \Ups_address\UPSaddressStruct\Ups_addressErrorDetailType) {
            throw new \InvalidArgumentException(sprintf('The ErrorDetail property can only contain items of type \Ups_address\UPSaddressStruct\Ups_addressErrorDetailType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ErrorDetail[] = $item;
        return $this;
    }
    /**
     * Get TransactionReference value
     * @return \Ups_address\UPSaddressStruct\Ups_addressTransactionReferenceType|null
     */
    public function getTransactionReference()
    {
        return $this->TransactionReference;
    }
    /**
     * Set TransactionReference value
     * @param \Ups_address\UPSaddressStruct\Ups_addressTransactionReferenceType $transactionReference
     * @return \Ups_address\UPSaddressStruct\Ups_addressErrors
     */
    public function setTransactionReference(\Ups_address\UPSaddressStruct\Ups_addressTransactionReferenceType $transactionReference = null)
    {
        $this->TransactionReference = $transactionReference;
        return $this;
    }
}
