<?php

namespace Ups_address\UPSaddressStruct;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for LocationType UPSaddressStruct
 * @package Ups_address
 * @subpackage Structs
 */
class Ups_addressLocationType extends AbstractStructBase
{
    /**
     * The LocationElementName
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $LocationElementName;
    /**
     * The XPathOfElement
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $XPathOfElement;
    /**
     * The OriginalValue
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $OriginalValue;
    /**
     * Constructor method for LocationType
     * @uses Ups_addressLocationType::setLocationElementName()
     * @uses Ups_addressLocationType::setXPathOfElement()
     * @uses Ups_addressLocationType::setOriginalValue()
     * @param string $locationElementName
     * @param string $xPathOfElement
     * @param string $originalValue
     */
    public function __construct($locationElementName = null, $xPathOfElement = null, $originalValue = null)
    {
        $this
            ->setLocationElementName($locationElementName)
            ->setXPathOfElement($xPathOfElement)
            ->setOriginalValue($originalValue);
    }
    /**
     * Get LocationElementName value
     * @return string|null
     */
    public function getLocationElementName()
    {
        return $this->LocationElementName;
    }
    /**
     * Set LocationElementName value
     * @param string $locationElementName
     * @return \Ups_address\UPSaddressStruct\Ups_addressLocationType
     */
    public function setLocationElementName($locationElementName = null)
    {
        // validation for constraint: string
        if (!is_null($locationElementName) && !is_string($locationElementName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($locationElementName, true), gettype($locationElementName)), __LINE__);
        }
        $this->LocationElementName = $locationElementName;
        return $this;
    }
    /**
     * Get XPathOfElement value
     * @return string|null
     */
    public function getXPathOfElement()
    {
        return $this->XPathOfElement;
    }
    /**
     * Set XPathOfElement value
     * @param string $xPathOfElement
     * @return \Ups_address\UPSaddressStruct\Ups_addressLocationType
     */
    public function setXPathOfElement($xPathOfElement = null)
    {
        // validation for constraint: string
        if (!is_null($xPathOfElement) && !is_string($xPathOfElement)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($xPathOfElement, true), gettype($xPathOfElement)), __LINE__);
        }
        $this->XPathOfElement = $xPathOfElement;
        return $this;
    }
    /**
     * Get OriginalValue value
     * @return string|null
     */
    public function getOriginalValue()
    {
        return $this->OriginalValue;
    }
    /**
     * Set OriginalValue value
     * @param string $originalValue
     * @return \Ups_address\UPSaddressStruct\Ups_addressLocationType
     */
    public function setOriginalValue($originalValue = null)
    {
        // validation for constraint: string
        if (!is_null($originalValue) && !is_string($originalValue)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($originalValue, true), gettype($originalValue)), __LINE__);
        }
        $this->OriginalValue = $originalValue;
        return $this;
    }
}
