<?php

namespace Ups_address;

/**
 * Class which returns the class map definition
 * @package Ups_address
 */
class Ups_addressClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'UPSSecurity' => '\\Ups_address\\UPSaddressStruct\\Ups_addressUPSSecurity',
            'UsernameToken' => '\\Ups_address\\UPSaddressStruct\\Ups_addressUsernameToken',
            'ServiceAccessToken' => '\\Ups_address\\UPSaddressStruct\\Ups_addressServiceAccessToken',
            'ClientInformationType' => '\\Ups_address\\UPSaddressStruct\\Ups_addressClientInformationType',
            'Property' => '\\Ups_address\\UPSaddressStruct\\Ups_addressProperty',
            'RequestType' => '\\Ups_address\\UPSaddressStruct\\Ups_addressRequestType',
            'TransactionReferenceType' => '\\Ups_address\\UPSaddressStruct\\Ups_addressTransactionReferenceType',
            'ResponseType' => '\\Ups_address\\UPSaddressStruct\\Ups_addressResponseType',
            'CodeDescriptionType' => '\\Ups_address\\UPSaddressStruct\\Ups_addressCodeDescriptionType',
            'Errors' => '\\Ups_address\\UPSaddressStruct\\Ups_addressErrors',
            'ErrorDetailType' => '\\Ups_address\\UPSaddressStruct\\Ups_addressErrorDetailType',
            'CodeType' => '\\Ups_address\\UPSaddressStruct\\Ups_addressCodeType',
            'LocationType' => '\\Ups_address\\UPSaddressStruct\\Ups_addressLocationType',
            'XAVRequest' => '\\Ups_address\\UPSaddressStruct\\Ups_addressXAVRequest',
            'XAVResponse' => '\\Ups_address\\UPSaddressStruct\\Ups_addressXAVResponse',
            'AddressKeyFormatType' => '\\Ups_address\\UPSaddressStruct\\Ups_addressAddressKeyFormatType',
            'CandidateType' => '\\Ups_address\\UPSaddressStruct\\Ups_addressCandidateType',
            'AddressClassificationType' => '\\Ups_address\\UPSaddressStruct\\Ups_addressAddressClassificationType',
        );
    }
}
